
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>FreeBSD 5.0中强制访问控制机制的使用与源代码分析【转】 / 憋错料</title>

    <meta name="description" content="FreeBSD 5.0中强制访问控制机制的使用与源代码分析【转】 本文主要讲述FreeBSD 5.0操作系统中新增的重要安全机制,即强制访问控制机制(MAC)的使用与源代码分析,主要包括强制访问控制框架及多级安全(MLS)策略两部分内容.这一部分讲述要将MAC框架与MLS策略用起来,应该做的一些工作,以及如何有效使用它们的问题. ? 强制访问控制(英文缩写MAC)是实现操作系统安全的一个重要的方法,现在几乎所有的安全操作系统都采用强制访问控制作为其核心安全机制之一.强制访问控制是对操作系统的各种客体(如文件.socket.系统FIFO.SCD.IPC等)进行细">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">FreeBSD 5.0中强制访问控制机制的使用与源代码分析【转】</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>本文主要讲述FreeBSD 5.0操作系统中新增的重要安全机制，即强制访问控制机制（MAC）的使用与源代码分析，主要包括强制访问控制框架及多级安全（MLS）策略两部分内容。这一部分讲述要将MAC框架与MLS策略用起来，应该做的一些工作，以及如何有效使用它们的问题。</p>
<p>?</p>
<p>强制访问控制（英文缩写MAC）是实现操作系统安全的一个重要的方法，现在几乎所有的安全操作系统都采用强制访问控制作为其核心安全机制之一。强制访问控制是对操作系统的各种客体（如文件、socket、系统FIFO、SCD、IPC等）进行细粒度的访问控制，即当用户或用户程序访问系统的某个客体时，强制访问控制机制对这种访问的安全性进行检查。与自主访问控制不同，强制访问控制对用户及用户程序的行为进行限制，从而达到更高的安全级别。</p>
<p>?</p>
<p>强制访问控制是一种机制，它对用户与用户程序对客体的访问进行检查，但什么样的访问是安全的呢？这就需要引入安全策略的概念。安全策略可以认为是一组检查条件，它为每次访问的主体（用户或用户程序）和被访问的客体（如文件等）定义一个安全标记，再根据主体和客体的安全标记来决定这次访问是否安全。目前已经开发出多种安全策略，其中MLS用得最多。MLS是多级安全的意思，它最早用于军事领域。它的基本思想是定义一些安全级，如从低到高分普通、机密、绝密等安全级，要求高安全级别的信息不能泄露给低安全级别的用户，这样就要求低安全级的主体不能读高安全级的客体，同时高安全级的主体不能写低安全级的客体。详情请参见有关资料。</p>
<p>?</p>
<p>与Linux一样，FreeBSD系统是开放源代码的操作系统，而且FreeBSD的结构清晰，安全性好，所以使用也很广泛。从5.0RC2版开始，FreeBSD内核开始引入强制访问控制机制。它在内核中实现了一个灵活通用MAC框架，这个框架对FreeBSD内核中几乎所有的核心对象进行了访问控制，并且这个框架设计合理、接口简洁，使得我们可以很方便地开发各种安全策略模块并将之挂接到系统，从而按我们自己的策略对系统进行安全控制。另外，系统还提供了包括MLS策略模块在内的多个策略模块供我们选用。</p>
<p>?</p>
<p>本文从使用与源代码的分析这两方面详细讲述FreeBSD系统中的强制访问控制机制，内容主要包括MAC框架和MLS策略，相信会对对此部分内容感兴趣的朋友有所启发。</p>
<h1>1 FreeBSD 5.0中强制访问控制机制的使用</h1>
<p>FreeBSD 5.0 RC2版本发布时，内核源代码中已经包含了MAC框架和一些MAC策略模块（如MLS策略模块、用于开发及实验的MAC_NONE策略模块、完整性模块MAC_BIBA等），但是这个版本的内核并没有正式对MAC提供支持，所以缺省情况下，在编译内核的时候没有把实现MAC框架的代码编译进去。另外，我们将以MLS策略为例，说明怎样利用MAC框架加载策略模块。为了让MLS策略真正实用，还需要配置系统的扩展文件属性等，我们将对之进行一定的介绍。最后我们将介绍如通过控制台命令以及在程序中如何使用系统调用接口对文件或进程的MAC标记进行操作。</p>
<h2>1.1 重新编译内核</h2>
<p>如上所述，由于FreeBSD 5.0 RC2版中的MAC框架还处于开发阶段，所以缺省情况下，内核二进制代码中并没有包括对MAC框架的支持。要使内核支持MAC框架，必须配置并重新编译内核，具体方法如下。</p>
<p>?</p>
<p>到/usr/src/sys/i386/conf下，把GENERIC文件复制成另一个文件如yxd_kernel（不要改动GENERIC文件），然后在yxd_kernel文件中找到makeoptions这个部分，仿照已有的格式，添加一行（详细信息请参见"FreeBSD Developers‘ Handbook"中的"TrustedBSD MAC FrameWork"章节）：</p>
<p>?</p>
<p>　　options MAC</p>
<p>?</p>
<p>这个选项将打开MAC编译开关，这样编译时将把相应的MAC框架代码编译进内核。</p>
<p>?</p>
<p>另外，为了支持文件及目录的MAC标记的存储，必须让内核支持扩展文件系统（缺省情况下也不支持）。要达到这个目的，必须在yxd_kernel中加入如下两个编译选项：</p>
<p>?</p>
<p>　mac_mls_load = "YES"</p>
<p>?</p>
<p>值得注意的一点是，当我们修改并重新编译了mac_mls.ko这个模块后，必须把它从/usr/src/sys/modules/mac_mls目录拷贝到/boot/kernel目录，因为系统启动的时候是从/boot/kernel目录寻找模块的。</p>
<h2>1.3 配置扩展文件系统</h2>
<p>?</p>
<p>当我们做完1.1和1.2两步后，MLS模块就已经在系统中起作用了，我们可以使用"getfmac 文件/目录名"来得到文件或目录的MAC标记（形如"文件/目录名: mls/low"，详细的介绍请参阅1.4节），但此时的标记是一种伪标记，也就是说，这个标记是MLS策略给每个文件的缺省标记，且这个标记在关闭系统的时候并没有被存储。但是按照我们的需要，我们希望每个文件或目录的MAC标记应该有"非易逝性"的标记，也就是说我们希望这个标记与文件一样被存储在磁盘上。这就需要引入扩展文件系统，使得每个文件或目录的MAC标记存储在对应文件或目录的扩展属性中。为了便于理解，下面对FreeBSD中的扩展文件系统进行一点简要的介绍。</p>
<p>?</p>
<p>简单地说，扩展文件系统是对现有文件系统的一种扩充。扩展属性（EA，Extended Attribute）是相对于传统文件系统的inode节点中已存储的文件或目录的标准属性而言的，它可以为inode节点中存储的文件或目录增加额外的信息，这些信息再由系统根据inode结点访问到。每个文件系统的扩展属性（EA）是一组（name，value）对。一个inode节点（文件或目录）可能定义了某种属性，也可能没有定义。如果inode节点定义了某个属性，则它可能包含0个，也可能包含多个字节的这种属性的数据。这与一般shell的环境变量类似。这样，扩展属性机制就为TrustedBSD的各种安全特征（ACL、MAC和能力等），提供了存储访问安全信息的简单方法。一些非安全应用也可以根据需要创建扩展属性，例如文件的校验和、密钥等。扩展属性可以动态地增加新的扩展属性而不必改变文件系统在磁盘上的存储格式。</p>
<p>?</p>
<p>如果使用的是MLS策略，那么返回的MAC标记为mls/[single_mac]([mac_range])，其中mls为策略名，后面用"/"与标记数据隔开。[single_mac]为单一的MAC标记，可能为"low"或"high"或"equal"。[mac_range]为一个MAC标记范围，往往主体（进程）有一个范围。一个MAC标记的例子为：mls/low(low-high)。</p>
<p>?</p>
<p>在应用程序中，可以使用的系统调用请参见/usr/src/sys/sys/mac.h文件中#ifndef _KERNEL这个块中提供的函数原型，值得注意的是，man page中的有些接口参数及返回值类型有误，请以mac.h文件中的类型为准。</p>
<p>?</p>
<p>下面是几个最常用的函数的使用方法：</p>
<ul>
<li>mac_get_proc，mac_get_file的用法：</li>
</ul>
<p>　　　 struct mac myMac;<br />　　　　char ss[60] = "mls";<br />　　　　myMac.m_string = ss;<br />　　　　myMac.m_buflen = 60;<br />　　　　mac_get_proc(&amp;myMac);<br />　　　　mac_get_file("/tmp/test",&amp;myMac);</p>
<ul>
<li>mac_set_proc，mac_set_file的用法：</li>
</ul>
<p>　　　 struct mac myMac;<br />　　　　myMac.m_string = "mls/high";<br />　　　　myMac.m_buflen = strlen(myMac.m_string);<br />　　　　mac_set_proc(&amp;myMac);<br />　　　　mac_set_file("/tmp/test",&amp;myMac);</p>
<h2>1.5 小结</h2>
<p>由于FreeBSD 5.0RC2版才刚刚开始非正式地支持MAC，所以针对普通用户而言，要将其真正用起来，要做的工作还比较多比较烦琐的。对于MLS策略而言，还有很多值得完善的地方，比如现有的MLS策略不支持对用户设置MAC标记，主体对客体访问的时候限制过多，还有MLS不支持可信进程等等，都是下一个版本需要完善的。</p>
<p>?</p>
<p>在使用上，从我个人的使用经验来看，比较不好用。当然，这个问题不能全怪系统，MLS策略导致易用性降低已经是不争的事实，相信经过一段时间的开发，最终会给我们一个满意的答案。</p>
<p>?</p>
<p>但是瑕不掩玉，撇开MLS，单看MAC框架，应该说是设计得很完美的：良好的结构、清晰的逻辑、非常简洁的接口，这些优点应该来说可以给每一个对它有兴趣的人一个大大的惊喜。即使是MLS策略，由于其作为一个KLD模块来实现，所以十分便于我们对它进行修改和扩充，相信经过一段时间，MLS模块亦会成为我们的惊喜。如果大家有兴趣了解MAC框架及MLS策略的实现，请接着往下阅读。</p>
<p>?</p>
<p>本文主要讲述FreeBSD 5.0操作系统中新增的重要安全机制，即强制访问控制机制（MAC）的使用与源代码分析，主要包括强制访问控制框架及多级安全（MLS）策略两部分内容。这一部分较系统地对MAC框架及MLS策略的源代码进行分析。</p>
<h1>2 MAC框架与MLS策略源代码分析</h1>
<p>与本文相关的源代码文件主要有两个，即 /usr/src/sys/kern/kern_mac.c 和 /usr/src/sys/security/mac_mls/mac_mls.c 。另外还有一些头文件如mac.h、mac_policy.h等。</p>
<h2>2.1 MAC框架整体结构</h2>
<p>?</p>
<p>下面是 MAC 框架的示意性结构图，当用户控制台或用户程序通过系统调用对内核对象进行访问的时候，由于内核代码中相应的位置插入了MAC框架的检查函数，于是内核就会调用MAC框架的相应检查函数来做安全性检查。MAC框架会依次调用每个挂接在MAC框架上的安全策略，以决定访问是否安全。另外，其它可能涉及到安全问题的系统事件，如初始化各种安全标记、初始化各种内核对象等，也会通知MAC框架，由它做出相应的处理。</p>
<p>?</p>
<p>从图中我们也可以看到，安全策略作为一个独立的KLD模块，可以独立于内核进行编译，再在使用的时候挂接到MAC框架上。要判断一次访问是否安全，MAC框架会调用所有的安全策略，只有当所有的安全策略均表示同意，MAC框架才会授权这次访问。</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzUwMjcxMS8yMDE0MDgvMTYwMDU3MTE1Nzc1MjU2LmdpZg==.jpg" /></p>
<h2>2.2 安全标记</h2>
<p>?</p>
<p>安全标记是由MAC框架和各个安全策略定义的一组数据，用于描述主体或客体的安全信息，安全标记与内核描述主客体的其它数据一起存储在内核中。要实现强制访问控制，首先必须为主客体定义安全标记。不同的策略由于判断的依据不一样，可能定义的标记也不相同。作为MAC框架，当安全策略向它注册的时候，它必须把该策略使用的安全标记附加到各个内核对象上去，这样当需要调用该策略做安全性检查的时候，才能为策略提供它们自己定义和理解的安全标记。我们先给出MAC框架与MLS策略定义的安全标记，再对之作进一步的解释。</p>
<p>?</p>
<p>MAC框架中安全标记的定义是这样的：</p>
<p>?</p>
<p>struct label {<br />　　int l_flags;<br />　　union {<br />　　　　void　　*l_ptr;<br />　　　　long　　 l_long;<br />　　}　 l_perpolicy[MAC_MAX_POLICIES];<br />};</p>
<p>?</p>
<p>其中l_flags是一个标志，被MAC框架用来判断是否初始化了整个标记数据结构。l_perpolicy数组为每个策略定义了一个联合，这样当策略向MAC框架注册时，它们既可以用一个long类的整数作为它们自己的安全标记，也可以使用联合中的指针指向一个它们自己定义的标记数据结构。MLS策略选择了后者。</p>
<p>?</p>
<p>MLS策略定义的安全标记是这们的：</p>
<p>?</p>
<p>struct mac_mls_element {<br />　　u_short mme_type;<br />　　u_short mme_level;<br />　　u_char　mme_compartments[MAC_MLS_MAX_COMPARTMENTS &gt;&gt; 3];<br />};<br />struct mac_mls {<br />　　int　　　　 mm_flags;<br />　　struct mac_mls_element　mm_single;<br />　　struct mac_mls_element　mm_rangelow, mm_rangehigh;<br />};</p>
<p>?</p>
<p>在mac_mls结构中，定义了一个单一标记（mm_single）和一个标记范围（mm_rangelow，mm_rangehigh），主客体既可以使用单一标记来标识单一安全级，也可以使用标记范围来标识一个安全级范围，还可以同时使用二者。如第1章中我们使用getfmac得到的输出"mls/high"表明该文件使用的是值为"high"的单一安全标记。再比如我们使用getpmac得到的输出"mls/low(low-high)"表明进程同时使用了单一标记和标记范围。至于究竟使用的是哪种标记，由mm_flags标识。</p>
<p>?</p>
<p>mac_mls_element定义一个标记，它定义的标记功能很强大，既支持安全类型（mme_type变量，值为LOW、HIGH、EQUAL和UNDEFINE），也支持多达256个级别的安全级（当mme_type的值为LEVEL时，mme_level变量有效，由它定义安全级），同时还使用mme_compartments数组支持域（field），后续章节将具体讲述MLS策略是怎样使用它所定义的标记的。</p>
<p>?</p>
<p>当用户试图打开一个文件时，内核就会试图打开一个vnode，在打开之前会调用这个函数，用于检查主体是否有权限打开这个vnode。MAC_CHECK宏定义如下：</p>
<p>?</p>
<p>#define MAC_CHECK(check, args...) do {　　　　　　　　　<br />　　struct mac_policy_conf *mpc;　　　　　　　　　　<br />　　　　　　　　　　　　　　　　　　<br />　　error = 0;　　　　　　　　　　　　　<br />　　MAC_POLICY_LIST_BUSY();　　　　　　　　　　<br />　　LIST_FOREACH(mpc, &amp;mac_policy_list, mpc_list) {　　　　<br />　　　　if (mpc-&gt;mpc_ops-&gt;mpo_ ## check != NULL)　　　　<br />　　　　　　error = error_select(　　　　　　　<br />　　　　　　　　mpc-&gt;mpc_ops-&gt;mpo_ ## check (args),　　<br />　　　　　　　　error);　　　　　　　　<br />　　}　　　　　　　　　　　　　　　<br />　　MAC_POLICY_LIST_UNBUSY();　　　　　　　　　<br />} while (0)</p>
<p>?</p>
<p>我们可以看到，代码中使用LIST_FOREACH宏来遍历安全策略链表中的每个策略，然后调用其在mpc_ops中注册的检查函数mpo_##check。mac_policy_ops这个结构中定义了很多事件处理函数，进行细粒度的访问控制，限于篇幅，在此不一一列出。这些函数共分四类：第一类是策略本身的初始化和销毁函数；第二类是对安全标记的操作函数，包括各种内核对象的安全标记的初始化与销毁函数，以及获取与设置安全标记的接口函数；第三类是对文件系统、网络系统及进程对象的标记进行操作的事件处理函数；第四类是检查对各个内核对象的访问是否安全的检查函数。详见mac_policy.h。</p>
<p>?</p>
<h2>2.4 安全策略的注册</h2>
<p>?</p>
<p>分析MLS策略，我们可以发现，安全策略向MAC框架注册是一件很简单的事情。mac_mls.c文件中花了大量篇幅定义了所有的事件处理函数，如前所述，这些函数是安全策略的核心，用于判断访问的安全性等。定义完这些函数后，在源代码的最后，把这些函数的地址填入mac_policy_ops结构中，再用一个MAC_POLICY_SET宏把mac_policy_ops结构挂接到上面提到的mac_policy_list链表中去就可以了，如下：</p>
<p>?</p>
<p>MAC_POLICY_SET(&amp;mac_mls_ops, trustedbsd_mac_mls, "TrustedBSD MAC/MLS", MPC_LOADTIME_FLAG_NOTLATE, &amp;mac_mls_slot);</p>
<p>?</p>
<p>mac_policy_modevent函数的核心代码如下：</p>
<p>?</p>
<p>case MOD_LOAD:<br />　　　　if (mpc-&gt;mpc_loadtime_flags &amp; MPC_LOADTIME_FLAG_NOTLATE &amp;&amp;<br />　　　　　　mac_late) {<br />　　　　　　printf("mac_policy_modevent: can‘t load %s policy "<br />　　　　　　　　"after booting", mpc-&gt;mpc_name);<br />　　　　　　error = EBUSY;<br />　　　　　　break;<br />　　　　}<br />　　　　error = mac_policy_register(mpc);<br />　　　　break;<br />　　case MOD_UNLOAD:<br />　　　　/* Don‘t unregister the module if it was never registered. */<br />　　　　if ((mpc-&gt;mpc_runtime_flags &amp; MPC_RUNTIME_FLAG_REGISTERED) != 0)<br />　　　　　　error = mac_policy_unregister(mpc);<br />　　　　else<br />　　　　　　error = 0;<br />　　　　break;</p>
<p>?</p>
<p>当模块被LOAD的时候，会调用 mac_policy_register函数，它首先检查该模块是否已注册，如果没有，就会执行下面的代码： LIST_INSERT_HEAD(&amp;mac_policy_list, mpc, mpc_list);</p>
<p>其中mpc为我们上面提到的mac_policy_conf结构的地址，这样到此为止，就把MLS策略添加到MAC框架的策略列表中去了。</p>
<p>　　<br />
?</p>
<h2>2.5 MLS策略源代码分析</h2>
<p>?</p>
<p>根据MLS策略，高安全级别的主体不能写低安全级别的客体，而低安全级别的主体则不能读高安全级别的客体，只有主客体的安全级别相同，才能既读又写。MLS定义了三种标记比较函数：</p>
<p>　　<br />
?</p>
<p>mac_mls_dominate_single(a,b)：用于检查a的单一标记的安全级是否高于b的单一标记的安全级。这个函数主要用于对内核变量的读、写、查询等事件进行安全性检查。</p>
<p>?</p>
<p>我们只解释一下最后一个case，即当a、b的类型均为MAC_MLS_TYPE_LEVEL时，也就是它们都使用一个数（0到254）标识它们的安全级时，判断是如何进行的。首先：</p>
<p>　　<br />#define MAC_MLS_BIT_TEST(b, w) ((w)[(((b) - 1) &gt;&gt; 3)] &amp; (1 &lt;&lt; (((b) - 1) &amp; 7)))</p>
<p>?</p>
<p>我们可以看到，在比较二者安全级之前，对它们的mme_compartments进行了位测试。mme_compartments是一个256bit的数据（由uchar[32]数组定义），每个bit都可以设置为1来表示该对象属于某一个安全域，当然也可以设置多个bit表示这个对象属于多个安全域。MLS要求如果a可以访问b的话，b所属的安全域必须要是a的子集，否则访问被拒绝。对mme_compartments进行测试的目的也即是要判断b中设置了1的那些bit在a中有否设置。</p>
<p>?</p>
<h2>2.6 对MAC框架及MLS策略的扩充</h2>
<p>?</p>
<p>最后我们对MAC框架作一点改进。前面提过，MAC框架目前并不支持对用户的安全级进行设置，也没有提供存储用户安全级信息的地方，我们想对之做改进，以使其更实用。我们改进的思想是，拦截系统的setuid系统调用，在系统作setuid的时候（用户登录、运行su命令等），读入用户安全级别信息并作相应设置。我们做了如下工作：</p>
<ul>
<li>在mac_policy.h文件中的mac_policy_ops结构中增加一个新函数mpo_get_cred_from_file()，其参数和返回值与mpo_create_cred()完全一样。</li>
<li>在mac_mls.c文件中增加一个新函数mac_mls_get_cred_from_file()，其参数和返回值与mac_mls_create_cred()完全一样。在这个函数里，增加在内核中读写用户安全级配置文件的语句，从而把用户的安全级在这里读到标记中。然后在对mac_policy_ops结构的设置语句中，增加一条语句：.mpo_get_cred_from_file = mac_mls_get_cred_from_file。</li>
<li>在kern_prot.c文件中的setuid()函数里crcopy()函数替换为我们自己的mac_crcopy()函数，并在调用这个函数之前加一条语句：newcred-&gt;cr_uid = uid;。</li>
</ul>
<p>　　<br />
?</p>
<p>mac_crcopy()函数的代码如下：</p>
<p>?</p>
<p>void mac_crcopy(struct ucred *dest,struct ucred *src)<br />{<br />　　uid_t uid = dest-&gt;cr_uid;<br />　　KASSERT(crshared(dest) == 0,("crcopy of shared ucred"));<br />　　bcopy(&amp;src-&gt;cr_startcopy,&amp;dest-&gt;cr_startcopy,<br />　　　　(unsigned)((caddr_t)&amp;src-&gt;cr_endcopy -<br />　　　　　　(caddr_t)&amp;src-&gt;cr_startcopy));<br />　　uihold(dest-&gt;cr_uidinfo);<br />　　uihold(dest-&gt;cr_ruidinfo);<br />　　if(jailed(dest))<br />　　　　prison_hold(dest-&gt;cr_prison);<br />#ifdef MAC<br />　　dest-&gt;cr_uid = uid;<br />　　mac_get_cred(src,dest);<br />　　dest-&gt;cr_uid = src-&gt;cr_uid;<br />#endif<br />}</p>
<p>修改相应的头文件，并重新编译内核。</p>
<h2>2.7 小结</h2>
<p>?</p>
<p>上面分析了MAC框架与MLS策略的主要内容，限于篇幅，我们只给出主要逻辑，如果您想要了解更为详细的技术细节，请阅读其源代码或联系我。另外，MAC框架和MLS策略还用到了一些很重要的技术，如系统控制（sysctl）机制、锁等，我们也没有提到，如有兴趣的读者可以继续钻研。</p>
<p>?</p>
<p>SRC=<a href="http://www.fengfly.com/plus/view-34134-1.html" rel="external nofollow noreferrer">http://www.fengfly.com/plus/view-34134-1.html</a></p>
<p><P><A href="http://www.bubuko.com/infodetail-315866.html" rel="external nofollow noreferrer">FreeBSD 5.0中强制访问控制机制的使用与源代码分析【转】,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 22:14:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/des/" title="des">des</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%87%e4%bb%b6/" title="文件">文件</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>FreeBSD 5.0中强制访问控制机制的使用与源代码分析【转】的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBGKDJ0.html" rel="bookmark">安胜操作系统安全机制【自主访问控制、强制访问控制、多级安全等实验】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.实验目的 1.    熟悉安胜安全操作系统的运行环境 2.    熟悉安胜安全操作系统基本安全机制的工作原理 二.实验内容 1．参考用户手册,熟悉常用的安全管理命令 2．自己设计测试案例,以展现以下安全机制的工作原理: (1)自主访问控制机制 (2)强制访问控制机制 (3)基于角色访问控制 (4)可信路径机制 (5)审计机制(可选) 三.实验过程.结果 (1)自主访问控制机制 创建三个用户: useradd user1 useradd user2 useradd user3 在user1下创			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vAPlo0.html" rel="bookmark">Objective-C中的属性机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Objective-C 2.0中的属性机制为我们提供了便捷的获取和设置实例变量的方式,也可以说属性为我们提供了一个默认的设置器和访问器的实现.在学习OC中属性之前我们先要知道为什么要为变量实现getter和setter方法,我们先来了解一下实例的作用域. 实例变量的作用域如下: 1. @public : 共有的,该实例变量谁都可以访问: [email protected] :受保护的,该实例变量只能在该类和其子类内访问,父类protected的实例变量在子类中是private的默认是protec			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Q22VkM.html" rel="bookmark">C&sol;C&plus;&plus; C&num; JAVA比教学------访问控制机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.java java中表示权限的关键字分别为public,protected,private.没有friendly这个,什么都不写的话也是一种不同的权限表示. class Mall { public String mallName; } class SuperMarket extends Mall { public void Show(){ System.out.println(&quot;THIS IS A SUPERMAKET:&quot;); System.out.println(mallName			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ekGPE4.html" rel="bookmark">Android应用Activity、Dialog、PopWindow、Toast窗体加入机制及源代码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[工匠若水 http://blog.csdn.net/yanbober 转载烦请注明出处.尊重劳动成果] 1 背景 之所以写这一篇博客的原因是由于之前有写过一篇&lt;Android应用setContentView与LayoutInflater载入解析机制源代码分析&gt;.然后有人在文章以下评论和微博私信中问我关于Android应用Activity.Dialog.PopWindow载入显示机制是咋回事,所以我就写一篇文章来分析分析吧(本文以Android5.1.1 (API 22)源代码为基础分析),以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4p6eKo0.html" rel="bookmark">MAC访问控制机制在Linux系统中的实现：SELinux</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SELinux全称:Security-Enhanced Linux,安全加强的Linux:SELinux系统的本来名称为MAC:强制访问控制:SELinux就是MAC访问控制机制在Linux系统中的实现: 操作系统安全等级标准(橙皮书): D级别(最低安全级别) C级别:C1, C2 (DAC自主访问控制,例如windows等系统的安全级别为C1级别) B级别:B1, B2, B3 (强制访问控制级别MAC) A级别(最高安全级别) 访问控制机制: DAC:Discretionary Acces			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dDp5w0.html" rel="bookmark">Java 理论与实践&colon; JDK 5&period;0 中更灵活、更具可伸缩性的锁定机制--转载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				多线程和并发性并不是什么新内容,但是 Java 语言设计中的创新之一就是,它是第一个直接把跨平台线程模型和正规的内存模型集成到语言中的主流语言.核心类库包含一个 Thread 类,可以用它来构建.启动和操纵线程,Java 语言包括了跨线程传达并发性约束的构造 ——synchronized 和 volatile .在简化与平台无关的并发类的开发的同时,它决没有使并发类的编写工作变得更繁琐,只是使它变得更容易了. synchronized 快速回顾 把代码块声明为 synchronized,有两个重			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pK8py3.html" rel="bookmark">Django2&period;0中URL的路由机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Django2.0中URL的路由机制 路由是关联url及其处理函数关系的过程.Django的url路由配置在settings.py文件中ROOT_URLCONF变量指定全局路由文件名称. Django的路由都写在urls.py文件中的urlpatterns列表中,由path()或re_path()作为元素组成. Django的URL路由流程: 1 Django查找全局urlpatterns变量(urls.py) 2 按照先后顺序,对URL逐一匹配urlpatterns每个元素 3 找到第一个匹配			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEvAqQ0.html" rel="bookmark">闲话Linux系统安全&lpar;二&rpar;&mdash;&mdash;强制访问控制&lpar;MAC&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				安全秘笈第二式--不安全的特殊权限和强制访问控制(MAC) 在DAC的机制中,不管是所有权加权限的管理办法,还是文件系统访问控制列表(facl),都是非常强大的访问控制机制,均可以对文件资源进行比较有效的访问控制.但DAC的自主性太强,可以说文件资源的安全在很大的程度上取决于使用者个人的意志,因此这种安全似乎就被主观化了.尤其是对于root用户而言,不管是权限和所有权的限制,还是facl的管理控制,都仅仅能够限制root的误操作而已. 在CentOS或RHEL系统中,每一个服务都需要以守护进程的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49k8bD0.html" rel="bookmark">在 Linux 上用 SELinux 或 AppArmor 实现强制访问控制（MAC）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为了解决标准的“用户-组-其他/读-写-执行”权限以及访问控制列表的限制以及加强安全机制,美国国家安全局(NSA)设计出一个灵活的强制访问控制Mandatory Access Control(MAC)方法 SELinux(Security Enhanced Linux 的缩写),来限制标准的权限之外的种种权限,在仍然允许对这个控制模型后续修改的情况下,让进程尽可能以最小权限访问或在系统对象(如文件,文件夹,网络端口等)上执行其他操作. 另一个流行并且被广泛使用的 MAC 是 AppArmor,相			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZV6Pl3.html" rel="bookmark" class="title">不错就是对方的讲课 会感觉会更好</a>
					<div>
						http://www.houzz.com/ideabooks/38903913/thumbs/ http://www.houzz.com/ideabooks/38903914/thumbs/ http ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBmrog4.html" rel="bookmark" class="title">stream~filestream</a>
					<div>
						http://blog.csdn.net/feliciafay/article/details/6157356 http://blog.csdn.net/feliciafay/article/deta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBAj7g4.html" rel="bookmark" class="title">方便调试使用的代码片段</a>
					<div>
						#region #warning 调试用,获取sql参数化的值,根据抛出的异常,复制sql明文到mssql中运行 string debugSql = queryHelper.CommandText;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q88aL3.html" rel="bookmark" class="title">Smack Message扩展，添加自定义元素&lpar;标签&rpar;经验分享</a>
					<div>
						Smack框架对XMPP协议进行了封装,从而方便与Openfire即时通信服务器做交互.说白了,Smack框架可以通过对象构造符合XMPP协议的XML字符串,避免手动拼接字符串. XMPP协议基本XM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Ammvd4.html" rel="bookmark" class="title">简单生活</a>
					<div>
						保持生活用品的必需.极简.洁净.优雅: 精心护理身体,保持洁净.健康.活力: 纯洁精神.心灵与灵魂. 细腻.宁静.全心投入地做每一件事: 或出行游玩,感受自然之美: 或做家务,静息静思. 适宜阅读.运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QA1Ao4.html" rel="bookmark" class="title">上班的第四百六十六天</a>
					<div>
						今天去迈瑞复试了,刚进去的时候那个技术总监就两只眼直勾勾地看着我,恨不得把脸贴过来.如果我是很渴望进这家公司,又容易紧张,说实话,我会紧张到发抖而且不知道该说啥.但他不知道我根本就不是很想进,而且平时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzeGy0.html" rel="bookmark" class="title">OpenGL基础渲染</a>
					<div>
						OpenGL渲染管线(简化版) 客户端-服务器 客户端是存储在CPU存储器中的,并且在应用程序中执行(或者驱动程序),驱动程序将渲染命令和数据组合起来,发动到服务器执行.服务器和客户机在功能上市异步的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgNZXN4.html" rel="bookmark" class="title">install OpenCV on Linux</a>
					<div>
						arch=$(uname -m) if [ &quot;$arch&quot; == &quot;i686&quot; -o &quot;$arch&quot; == &quot;i386&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/352aJo4.html" rel="bookmark" class="title">老男孩教育每日一题-第106天-MySQL如何授权用户admin&colon;password远程访问权限</a>
					<div>
						解答: 假定内网网段172.16.1.0,用户admin,密码password,数据库oldboy. 只创建用户: create user 'admin'@'172.16.1.%' identifie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWLR14.html" rel="bookmark" class="title">JAVA的IO操作：内存操作流</a>
					<div>
						掌握内存操作流 输入和输出都是从文件中来的,当然,也可将输出的位置设置在内存上,这就需要ByteArrayInputStream和ByteArrayOutputStream ByteArrayInpu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0leR5Z3.html" rel="bookmark" class="title">统计一行的不重复的单词字符个数</a>
					<div>
						源代码如下://输入# 号结束 #include&lt;stdio.h&gt; #include&lt;stdlib.h&gt; #include&lt;string.h&gt; char str[5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nY1mxM.html" rel="bookmark" class="title">BigBlueButton简介</a>
					<div>
						BigBlueButton是一套开源的视频会议系统,特别适用于远程教育但也可以用于标准的会议.该系统 可以让多个用户登录共享他们的摄像头并同时能够通过VOIP进行交流.可以在线演示PDF和Office ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mglxgp0.html" rel="bookmark" class="title">WCF 编程实验室</a>
					<div>
						最近由于项目需要,简单研究了一下.NET WCF编程. 首先,简单说下WCF是什么,WCF 本质上,是一种开发框架.它用来开发类似COM+ .WEB SERVICE 这样“远程方法调用” 功能. 普通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZKLB4.html" rel="bookmark" class="title">Linux基础&colon; 网络命令和进程管理</a>
					<div>
						? netstat lsof ps pstree pkill/kill (了解jenkins git,排查环境) 查询服务器之间是否有链接(netstat -an) 某个服务是否启动(了解服务对应的启 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nPN1X4.html" rel="bookmark" class="title">样式命名规范</a>
					<div>
						(一)常用的CSS命名规则 头:header内容:content/container尾:footer导航:nav侧栏:sidebar栏目:column页面外围控制整体布局宽度:wrapper左右中:l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLyox4.html" rel="bookmark" class="title">云服务器linux重新挂载指定目录（非扩充）</a>
					<div>
						新买的香港云服务器,系统只能在商家的控制台上安装. 系统和硬盘分开的,根目录空间只有10G.需要重新设置相关目录的大小,如:/usr./var./home等. 以下是自己的解决方法小计. 一.初始的分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47eozD0.html" rel="bookmark" class="title">VisualVM远程连接Tomcat</a>
					<div>
						最近项目已经要提测了,有时间来考虑一些性能上的事儿了.之前拜读过&lt;深入理解java虚拟机&gt;,只可惜当时功力尚浅,有些东西还是不太懂,而且应用场景也没有,所以借这次机会看看.当然了,这次并不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWd2Gl0.html" rel="bookmark" class="title">C&num;&period;NET 大型企业信息化系统集成快速开发平台 4&period;1 版本 - 面向数据库SQL语句的应用开发一</a>
					<div>
						我的梦想是给大家提供一个工具.可以用他来提高工作效率.就像战争上,你有一个得心应手的武器一个道理.  给大家一个性能良好的信息化武器,就是我的梦想. 有一个朋友来信息如下: 我就是企业维护信息的,也不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OXgQZ4.html" rel="bookmark" class="title">Xcode8 重新配置 CocoaPods -替换阿里源</a>
					<div>
						一.CocoaPods是什么? CocoaPods是一个负责管理iOS项目中第三方开源库的工具.CocoaPods的项目源码在Github上管理.该项目开始于2011年8月12日,在这两年多的时间里, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41yKpY4.html" rel="bookmark" class="title">AndroidJNI&period;SetShortArrayElement设置短整数数组元素</a>
					<div>
						staticfunction SetShortArrayElement (array : IntPtr, index : int, val : Int16) : void Description描述  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
